<?php
/**
 * Mysql Auth Module for Mediawiki
 *
 * Downgrade MediaWiki password hashing to md5 so that it becomes 
 * useable with the Mysql Auth Module for Apache.
 *
 * Does only work if you use $wgPasswordSalt = false; as configuration
 * setting (http://www.mediawiki.org/wiki/Manual:$wgPasswordSalt).
 *
 * NOTE: See http://opencrack.hashkiller.com/ for md5 hash security
 * NOTE: Mysql Auth Module does support other hashes and salts as well.
 *
 * SETUP:
 *
 *   add the following lines into your LocalSettings.php:
 *
 *     require_once(sprintf('%s/extensions/mod_auth_mysql.php', $IP));
 *     $wgPasswordSalt = false;
 *
 *   done.
 * 
 * @version 0.1
 * @date 2009-11-06
 * @author  Tom Klingenberg http://www.lastflood.com/
 * @license AGPL 3.0
 */

# bootstrap extension
Mysql_Auth_Module::bootstrap(); 


/**
 * Mysql_Auth_Module Mediawiki extension class
 */
class Mysql_Auth_Module {
	static $__instance = null;
	/**
	 * bootstrap mediawiki extension
	 */
	public static function bootstrap() {
		global $wgExtensionFunctions;
		$wgExtensionFunctions[] = array('Mysql_Auth_Module', 'bootstrapInstance');		
	}
	/**
	 * bootstrap instance
	 */
	public static function bootstrapInstance() {
		if (null == Mysql_Auth_Module::$__instance)
			Mysql_Auth_Module::$__instance = new Mysql_Auth_Module();
	}
	/**
	 * constrcutor
	 */
	public function __construct() {
		global $wgHooks;
		$wgHooks['UserCryptPassword'][] = array($this, 'UserCryptPassword');
	}
	/**
	 * UserCryptPassword mediwiki hook
	 * @-mw-hook UserCryptPassword
	 */
	public function UserCryptPassword(&$password, &$salt, &$wgPasswordSalt, &$hash) {
		if (false !== $wgPasswordSalt)
			throw new InvalidArgumentException(sprintf('wgPasswordSalt is not false (%s)', $wgPasswordSalt));
		$hash = md5($password);
		return false; # returning false means $hash should be taken. use true to override. return null to raise an exception.
	}
	
}
